Add unit test for AggregateException.GetBaseException that works on .net but is broke...
[mono.git] / mono / tests / Makefile.am
1 SUBDIRS = cas assemblyresolve gc-descriptors
2
3 check-local: test
4
5 aotcheck: testaot gshared-aot
6
7 TEST_PROG = ../interpreter/mint
8
9 JITTEST_PROG = $(if $(VALGRIND), valgrind $(VALGRIND_ARGS),) $(if $(SGEN),$(top_builddir)/mono/mini/mono-sgen,$(top_builddir)/mono/mini/mono)
10
11 TEST_PROG_RUN = MONO_SHARED_DIR=$(mono_build_root)/runtime MONO_CFG_DIR=$(mono_build_root)/runtime/etc $(LIBTOOL) --mode=execute $(TEST_PROG)
12 JITTEST_PROG_RUN = MONO_SHARED_DIR=$(mono_build_root)/runtime MONO_CFG_DIR=$(mono_build_root)/runtime/etc $(LIBTOOL) --mode=execute $(JITTEST_PROG)
13
14 RUNTIME_ARGS=--config tests-config --optimize=all --debug
15
16 with_mono_path = MONO_PATH=$(mcs_topdir)/class/lib/net_4_5
17
18 RUNTIME = $(with_mono_path) $(top_builddir)/runtime/mono-wrapper
19
20 MKBUNDLE = \
21         PKG_CONFIG_PATH=$(top_builddir):$(PKG_CONFIG_PATH) \
22         $(RUNTIME) $(mcs_topdir)/class/lib/net_4_5/mkbundle.exe
23
24 MCS = $(RUNTIME) $(mcs_topdir)/class/lib/build/mcs.exe -unsafe -debug \
25         -nowarn:0162 -nowarn:0168 -nowarn:0219 -nowarn:0414 -nowarn:0618 \
26         -nowarn:0169 -nowarn:1690 -nowarn:0649 -nowarn:0612 -nowarn:3021 \
27         -nowarn:0197
28 ILASM = $(RUNTIME) $(mcs_topdir)/class/lib/net_4_5/ilasm.exe
29
30 BENCHSRC=fib.cs random.cs nested-loops.cs ackermann.cs tight-loop.cs sieve.cs
31
32 STRESS_TESTS_SRC=       \
33         abort-stress-1.cs       \
34         abort-stress-2.cs       \
35         abort-stress-3.cs       \
36         domain-stress.cs        \
37         gchandle-stress.cs      \
38         monitor-stress.cs       \
39         thread-stress.cs        \
40         gc-stress.cs            \
41         exit-stress.cs          \
42         process-stress.cs       \
43         assembly-load-stress.cs
44
45 # Disabled until ?mcs is fixed
46 #       bug-331958.cs
47 BASE_TEST_CS_SRC=               \
48         bug-2907.cs             \
49         array-init.cs           \
50         arraylist.cs            \
51         assemblyresolve_event.cs        \
52         assemblyresolve_event3.cs       \
53         checked.cs              \
54         char-isnumber.cs        \
55         create-instance.cs      \
56         field-layout.cs         \
57         pack-layout.cs          \
58         pack-bug.cs             \
59         hash-table.cs           \
60         test-ops.cs             \
61         obj.cs                  \
62         test-dup-mp.cs          \
63         string.cs               \
64         stringbuilder.cs        \
65         switch.cs               \
66         outparm.cs              \
67         delegate.cs             \
68         bitconverter.cs         \
69         exception.cs            \
70         exception2.cs           \
71         exception3.cs           \
72         exception4.cs           \
73         exception5.cs           \
74         exception6.cs           \
75         exception7.cs           \
76         exception8.cs           \
77         exception10.cs          \
78         exception11.cs          \
79         exception12.cs          \
80         exception13.cs          \
81         exception14.cs          \
82         exception15.cs          \
83         exception16.cs          \
84         exception17.cs          \
85         typeload-unaligned.cs   \
86         struct.cs               \
87         valuetype-gettype.cs    \
88         typeof-ptr.cs           \
89         static-constructor.cs   \
90         pinvoke.cs              \
91         pinvoke2.cs             \
92         pinvoke3.cs             \
93         pinvoke11.cs            \
94         pinvoke13.cs            \
95         pinvoke17.cs            \
96         invoke.cs               \
97         invoke2.cs              \
98         runtime-invoke.cs               \
99         invoke-string-ctors.cs          \
100         reinit.cs               \
101         box.cs                  \
102         array.cs                \
103         enum.cs                 \
104         enum2.cs                \
105         property.cs             \
106         enumcast.cs             \
107         assignable-tests.cs     \
108         array-cast.cs           \
109         array-subtype-attr.cs   \
110         cattr-compile.cs        \
111         cattr-field.cs          \
112         cattr-object.cs         \
113         custom-attr.cs          \
114         double-cast.cs          \
115         newobj-valuetype.cs     \
116         arraylist-clone.cs      \
117         setenv.cs               \
118         vtype.cs                \
119         isvaluetype.cs          \
120         iface6.cs               \
121         iface7.cs               \
122         ipaddress.cs            \
123         array-vt.cs             \
124         interface1.cs           \
125         reflection-enum.cs      \
126         reflection-prop.cs      \
127         reflection4.cs          \
128         reflection5.cs          \
129         reflection-const-field.cs \
130         many-locals.cs          \
131         string-compare.cs       \
132         test-prime.cs           \
133         params.cs               \
134         reflection.cs           \
135         interface.cs            \
136         iface.cs                \
137         iface2.cs               \
138         iface3.cs               \
139         iface4.cs               \
140         iface-large.cs          \
141         virtual-method.cs       \
142         intptrcast.cs           \
143         indexer.cs              \
144         stream.cs               \
145         console.cs              \
146         shift.cs                \
147         jit-int.cs              \
148         jit-uint.cs             \
149         jit-long.cs             \
150         long.cs                 \
151         jit-ulong.cs            \
152         jit-float.cs            \
153         pop.cs                  \
154         time.cs                 \
155         appdomain.cs        \
156         appdomain1.cs           \
157         appdomain2.cs           \
158         appdomain-client.cs     \
159         appdomain-unload.cs \
160         appdomain-async-invoke.cs       \
161         loader.cs       \
162         pointer.cs              \
163         hashcode.cs             \
164         delegate1.cs            \
165         delegate2.cs            \
166         delegate3.cs            \
167         delegate5.cs            \
168         delegate6.cs            \
169         delegate7.cs            \
170         delegate8.cs            \
171         delegate9.cs            \
172         remoting1.cs            \
173         remoting2.cs            \
174         remoting3.cs            \
175         remoting4.cs            \
176         remoting5.cs            \
177         largeexp.cs             \
178         largeexp2.cs            \
179         marshalbyref1.cs        \
180         static-ctor.cs          \
181         inctest.cs              \
182         bound.cs                \
183         array-invoke.cs         \
184         test-arr.cs             \
185         decimal.cs              \
186         decimal-array.cs        \
187         marshal.cs              \
188         marshal1.cs             \
189         marshal2.cs             \
190         marshal3.cs             \
191         marshal5.cs             \
192         marshal6.cs             \
193         marshal7.cs             \
194         marshal8.cs             \
195         marshal9.cs             \
196         marshalbool.cs          \
197         marshal-valuetypes.cs   \
198         test-byval-in-struct.cs \
199         thread.cs               \
200         thread5.cs              \
201         thread6.cs              \
202         thread-static.cs        \
203         thread-static-init.cs   \
204         context-static.cs       \
205         float-pop.cs            \
206         interfacecast.cs        \
207         array3.cs               \
208         classinit.cs            \
209         classinit2.cs           \
210         synchronized.cs         \
211         async_read.cs           \
212         threadpool.cs           \
213         threadpool1.cs          \
214         threadpool-exceptions1.cs \
215         threadpool-exceptions2.cs \
216         threadpool-exceptions3.cs \
217         threadpool-exceptions4.cs \
218         threadpool-exceptions5.cs \
219         threadpool-exceptions6.cs \
220         threadpool-exceptions7.cs \
221         base-definition.cs      \
222         bug-27420.cs            \
223         bug-47295.cs            \
224         bug-46781.cs            \
225         bug-48015.cs            \
226         bug-42136.cs            \
227         bug-59286.cs            \
228         bug-70561.cs            \
229         bug-78311.cs            \
230         bug-78653.cs            \
231         bug-78656.cs            \
232         bug-77127.cs            \
233         bug-323114.cs           \
234         bug-Xamarin-5278.cs     \
235         interlocked.cs          \
236         cross-domain.cs         \
237         appdomain-exit.cs       \
238         delegate-async-exit.cs  \
239         delegate-delegate-exit.cs       \
240         delegate-exit.cs        \
241         finalizer-abort.cs      \
242         finalizer-exception.cs  \
243         finalizer-exit.cs       \
244         finalizer-thread.cs     \
245         main-exit.cs    \
246         main-returns-abort-resetabort.cs        \
247         main-returns-background-abort-resetabort.cs     \
248         main-returns-background-resetabort.cs   \
249         main-returns-background.cs      \
250         main-returns-background-change.cs       \
251         main-returns.cs         \
252         subthread-exit.cs       \
253         desweak.cs              \
254         cominterop.cs           \
255         exists.cs               \
256         handleref.cs    \
257         transparentproxy.cs \
258         dbnull-missing.cs       \
259         test-type-ctor.cs       \
260         soft-float-tests.cs     \
261         thread-exit.cs          \
262         finalize-parent.cs      \
263         assemblyresolve_event2.2.cs     \
264         interlocked-2.2.cs      \
265         pinvoke-2.2.cs          \
266         bug-78431.2.cs          \
267         bug-79684.2.cs          \
268         catch-generics.2.cs     \
269         event-get.2.cs          \
270         safehandle.2.cs         \
271         stackframes-async.2.cs          \
272         module-cctor-loader.2.cs        \
273         generics-invoke-byref.2.cs      \
274         generic-signature-compare.2.cs  \
275         generics-sharing.2.cs   \
276         shared-generic-methods.2.cs     \
277         shared-generic-synchronized.2.cs        \
278         generic-inlining.2.cs   \
279         generic-initobj.2.cs    \
280         generic-delegate.2.cs   \
281         generic-sizeof.2.cs     \
282         generic-virtual.2.cs    \
283         generic-interface-methods.2.cs  \
284         generic-array-type.2.cs \
285         generic-method-patching.2.cs    \
286         generic-static-methods.2.cs     \
287         generic-null-call.2.cs  \
288         generic-special.2.cs    \
289         generic-exceptions.2.cs \
290         generic-virtual2.2.cs   \
291         generic-valuetype-interface.2.cs        \
292         generic-getgenericarguments.2.cs        \
293         generic-type-builder.2.cs       \
294         generic-synchronized.2.cs       \
295         generic-delegate-ctor.2.cs      \
296         generic-array-iface-set.2.cs    \
297         generic-typedef.2.cs    \
298         generic-marshalbyref.2.cs       \
299         generic-xdomain.2.cs    \
300         bug-431413.2.cs \
301         bug-459285.2.cs \
302         generic-virtual-invoke.2.cs     \
303         bug-461198.2.cs \
304         generic-sealed-virtual.2.cs     \
305         generic-system-arrays.2.cs      \
306         generic-stack-traces.2.cs       \
307         generic-stack-traces2.2.cs      \
308         bug-472600.2.cs \
309         recursive-generics.2.cs \
310         bug-473482.2.cs \
311         bug-473999.2.cs \
312         bug-479763.2.cs \
313         bug-616463.cs   \
314         bug-80392.2.cs          \
315         dynamic-method-access.2.cs      \
316         dynamic-method-finalize.2.cs    \
317         bug-82194.2.cs  \
318         anonarray.2.cs  \
319         ienumerator-interfaces.2.cs     \
320         array-enumerator-ifaces.2.cs    \
321         generic_type_definition_encoding.2.cs \
322         generic_type_definition.2.cs    \
323         bug-333798.2.cs         \
324         bug-333798-tb.2.cs              \
325         bug-335131.2.cs         \
326         bug-322722_patch_bx.2.cs                \
327         bug-348522.2.cs         \
328         bug-340662_bug.cs       \
329         bug-322722_dyn_method_throw.2.cs        \
330         bug-389886-2.cs \
331         bug-325283.2.cs \
332         thunks.cs \
333         winx64structs.cs \
334         bug-349190.2.cs \
335         nullable_boxing.2.cs    \
336         valuetype-equals.cs     \
337         custom-modifiers.2.cs   \
338         bug-382986.cs   \
339         test-inline-call-stack.cs       \
340         bug-324535.cs   \
341         modules.cs      \
342         bug-81673.cs    \
343         bug-81691.cs    \
344         bug-80307.cs    \
345         bug-415577.cs   \
346         filter-stack.cs \
347         vararg2.cs      \
348         bug-389886-sre-generic-interface-instances.cs   \
349         bug-461867.cs   \
350         bug-461941.cs   \
351         bug-461261.cs   \
352         bug-400716.cs   \
353         bug-462592.cs   \
354         bug-459094.cs   \
355         generic-unloading.2.cs  \
356         generic-unloading-sub.2.cs      \
357         bug-467456.cs   \
358         appdomain-unload-callback.cs    \
359         bug-508538.cs   \
360         bug-472692.2.cs         \
361         gchandles.cs    \
362         interlocked-3.cs        \
363         interlocked-4.2.cs      \
364         appdomain-thread-abort.cs \
365         xdomain-threads.cs      \
366         w32message.cs   \
367         bug-544446.cs   \
368         gc-altstack.cs  \
369         large-gc-bitmap.cs      \
370         bug-561239.cs   \
371         bug-562150.cs   \
372         bug-575941.cs   \
373         bug-599469.cs   \
374         bug-389886-3.cs \
375         monitor.cs      \
376         dynamic-method-resurrection.cs  \
377         bug-666008.cs   \
378         bug-685908.cs   \
379         sgen-long-vtype.cs      \
380         delegate-invoke.cs      \
381         bug-696593.cs   \
382         bug-705140.cs   \
383         bug-1147.cs     \
384         mono-path.cs    \
385         bug-bxc-795.cs  \
386         bug-3903.cs     \
387         async-with-cb-throws.cs \
388         appdomain-unload-doesnot-raise-pending-events.cs        \
389         bug-6148.cs     \
390         assembly_append_ordering.cs     \
391         bug-10127.cs    \
392         allow-synchronous-major.cs      \
393         unload-appdomain-on-shutdown.cs \
394         block_guard_restore_aligment_on_exit.cs \
395         finally_block_ending_in_dead_bb.cs      \
396         thread_static_gc_layout.cs
397
398 TEST_CS_SRC_DIST=       \
399         $(BASE_TEST_CS_SRC)     \
400         async-exc-compilation.cs \
401         filter-stack.cs \
402         finally_guard.cs
403
404 TEST_CS_SRC_GEN = \
405         runtime-invoke.gen.cs \
406         imt_big_iface_test.cs
407
408 if AMD64
409 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN) async-exc-compilation.cs finally_guard.cs
410 # #651684
411 PLATFORM_DISABLED_TESTS = finally_guard.exe
412 else
413 if X86
414 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN) async-exc-compilation.cs finally_guard.cs
415 else
416 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN)
417 endif
418 endif
419
420 if IA64
421 TEST_CS_SRC+=async-exc-compilation.cs filter-stack.cs
422 # bug #319249
423 PLATFORM_DISABLED_TESTS=exception17.exe
424 PLATFORM_DISABLED_TESTS+=winx64structs.exe
425 endif
426
427 if X86
428
429 if HOST_WIN32
430 PLATFORM_DISABLED_TESTS=async-exc-compilation.exe finally_guard.exe
431 endif
432
433 endif
434
435 if POWERPC
436 # bug #71274
437 PLATFORM_DISABLED_TESTS=finalizer-abort.exe finalizer-exception.exe finalizer-exit.exe
438 endif
439
440 if ARM
441 PLATFORM_DISABLED_TESTS=filter-stack.exe
442 endif
443
444 if MIPS
445 # monitor.exe is racy
446 PLATFORM_DISABLED_TESTS=filter-stack.exe monitor.exe
447 endif
448
449 if S390X
450 PLATFORM_DISABLED_TESTS=dynamic-method-resurrection.exe
451 #PLATFORM_DISABLED_TESTS=dynamic-method-resurrection.exe exception17.exe
452 endif
453
454 if NACL_CODEGEN
455 # Tests that use Thread.Abort()
456 PLATFORM_DISABLED_TESTS= abort-stress-1.exe \
457                          abort-stress-2.exe \
458                          abort-stress-3.exe \
459                          appdomain-thread-abort.exe \
460                          async-exc-compilation.exe \
461                          bug-561239.exe \
462                          bug-70561.exe \
463                          finalizer-abort.exe \
464                          finally_guard.exe \
465                          main-returns-abort-resetabort.exe \
466                          main-returns-background-abort-resetabort.exe \
467                          thread6.exe \
468                          threadpool-exceptions5.exe \
469                          threadpool-exceptions6.exe
470
471 # Tests that rely on AppDomain.Unload
472 PLATFORM_DISABLED_TESTS+= appdomain-async-invoke.exe \
473                           appdomain-exit.exe \
474                           appdomain-unload-callback.exe \
475                           appdomain-unload.exe \
476                           domain-stress.exe \
477                           generic-unloading.2.exe \
478                           monitor.exe \
479                           remoting4.exe \
480                           threadpool-exceptions7.exe \
481                           xdomain-threads.exe
482
483 # pinvoke2 attaches a thread to the runtime, but
484 # doesn't 'unattach' it and it hangs in GC on exit
485 PLATFORM_DISABLED_TESTS+= pinvoke2.exe
486
487 # Tests that currently hang waiting for non-main threads
488 # to exit in NaCl, need to investigate.  Most are AppDomain
489 # creation and Delegate tests.
490 PLATFORM_DISABLED_TESTS+= appdomain1.exe \
491                           delegate9.exe \
492                           marshal-valuetypes.exe \
493                           cross-domain.exe \
494                           stackframes-async.2.exe \
495                           generic-marshalbyref.2.exe \
496                           generic-xdomain.2.exe \
497                           bug-415577.exe
498
499 # Tests that fail trying to write files (appdomain create mostly)
500 PLATFORM_DISABLED_TESTS+= bug-335131.2.exe \
501                           bug-349190.2.exe \
502                           bug-80307.exe \
503                           bug-462592.exe
504
505 # FIXME: don't know why delegate2.exe fails, it shouldn't
506 PLATFORM_DISABLED_TESTS+= delegate2.exe
507
508 # These tests newly fail with the latest revision. pinvoke3 fails because
509 # of a thread attach, the others have not been investigated.  TODO revisit.
510 PLATFORM_DISABLED_TESTS+= pinvoke3.exe \
511                           async_read.exe \
512                           async-with-cb-throws.exe \
513                           appdomain-unload-doesnot-raise-pending-events.exe \
514                           gsharing-valuetype-layout.exe
515
516 if X86
517 # FIXME: There are problems with async callbacks and results on NaCl 32-bit
518 PLATFORM_DISABLED_TESTS+= delegate1.exe \
519                           delegate3.exe \
520                           delegate5.exe \
521                           delegate8.exe \
522                           threadpool.exe \
523                           threadpool1.exe \
524                           threadpool-exceptions3.exe \
525                           bug-323114.exe \
526                           delegate-exit.exe \
527                           bug-80392.2.exe
528
529 # FIXME: These tests hang/fail for unknown reasons, deal with exiting
530 PLATFORM_DISABLED_TESTS+= main-returns-background-resetabort.exe \
531                           main-returns-background.exe \
532                           main-returns-background-change.exe
533 endif
534
535 endif
536
537 # The two finalizer tests only work under sgen
538 # gc-altstack.exe fails under boehm because it has no support for altstack
539 # bug-459094.exe creates an extremely deep directory tree
540 # delegate-invoke.exe depends on 929c6bc9b6d76a273f251e6f5dfacac36e9c38bd which was
541 # reverted.
542 DISABLED_TESTS=                 \
543         delegate-async-exception.exe    \
544         bug-348522.2.exe        \
545         bug-459094.exe \
546         delegate-invoke.exe \
547         $(PLATFORM_DISABLED_TESTS)
548
549 DISABLED_TESTS_WRENCH=  \
550         $(DISABLED_TESTS)       \
551         $(PLATFORM_DISABLED_TESTS_WRENCH)       \
552         main-returns-background-resetabort.exe \
553         main-returns-background-abort-resetabort.exe    \
554         thread6.exe     \
555         assemblyresolve_event3.exe \
556         delegate2.exe   \
557         finally_guard.exe \
558         gc-altstack.exe
559
560 AOT_DISABLED_TESTS=constraints-load.exe
561
562 # These only compile with MS CSC
563 TEST_CSC_SRC=                   \
564         vararg.cs
565
566 TEST_IL_SRC=                    \
567         field-access.il         \
568         method-access.il        \
569         ldftn-access.il         \
570         cpblkTest.il            \
571         vbinterface.il          \
572         calliTest.il            \
573         ckfiniteTest.il         \
574         fault-handler.il                \
575         locallocTest.il         \
576         initblkTest.il          \
577         qt-instance.il          \
578         vararg.il               \
579         bug-29859.il            \
580         bug-78549.il            \
581         static-fields-nonconst.il       \
582         reload-at-bb-end.il     \
583         test-enum-indstoreil.il \
584         filter-bug.il           \
585         even-odd.il             \
586         bug-82022.il    \
587         vt-sync-method.il       \
588         enum_types.il   \
589         invalid-token.il        \
590         call_missing_method.il  \
591         call_missing_class.il   \
592         ldfld_missing_field.il  \
593         ldfld_missing_class.il  \
594         find-method.2.il        \
595         bug-79215.2.il  \
596         bug-79956.2.il  \
597         bug-327438.2.il \
598         bug-387274.2.il \
599         bug-426309.2.il \
600         ldtoken_with_byref_typespec.2.il \
601         resolve_method_bug.2.il \
602         resolve_field_bug.2.il \
603         resolve_type_bug.2.il   \
604         generics-sharing-other-exc.2.il \
605         generic-ldobj.2.il      \
606         generic-mkrefany.2.il   \
607         generic-refanyval.2.il  \
608         generic-ldtoken.2.il    \
609         generic-ldtoken-method.2.il     \
610         generic-ldtoken-field.2.il      \
611         generic-tailcall.2.il   \
612         generic-tailcall2.2.il  \
613         generic-array-exc.2.il  \
614         generic-valuetype-newobj2.2.il  \
615         generic-valuetype-newobj.2.il   \
616         generic-constrained.2.il        \
617         generic-type-load-exception.2.il        \
618         bug-81466.il    \
619         bug457574.il    \
620         bug445361.il    \
621         bug-463303.il   \
622         bug469742.2.il  \
623         bug-528055.il   \
624         constraints-load.il     \
625         array_load_exception.il \
626         bug-481403.il   \
627         interface-with-static-method.il \
628         bug-515884.il   \
629         bug-633291.il   \
630         delegate-with-null-target.il    \
631         bug-318677.il   \
632         gsharing-valuetype-layout.il    \
633         invalid_generic_instantiation.il
634
635
636 # pre-requisite test sources: files that are not test themselves
637 # but that need to be compiled
638 PREREQ_IL_SRC=event-il.il module-cctor.il
639 PREREQ_CS_SRC=
640 PREREQ_IL_DLL_SRC=event-il.il module-cctor.il
641 PREREQ_CS_DLL_SRC=
642
643 PREREQSI_IL=$(PREREQ_IL_SRC:.il=.exe)
644 PREREQSI_CS=$(PREREQ_CS_SRC:.cs=.exe)
645 TESTSI_CS=$(TEST_CS_SRC:.cs=.exe)
646 TESTSI_IL=$(TEST_IL_SRC:.il=.exe)
647 TESTBS=$(BENCHSRC:.cs=.exe)
648 STRESS_TESTS=$(STRESS_TESTS_SRC:.cs=.exe)
649
650 EXTRA_DIST=test-driver $(TEST_CS_SRC_DIST) $(TEST_IL_SRC) \
651         $(BENCHSRC) $(STRESS_TESTS_SRC) stress-runner.pl $(PREREQ_IL_SRC) $(PREREQ_CS_SRC)
652
653 %.exe: %.il
654         $(ILASM) -out:$@ $<
655
656 %.exe: %.cs TestDriver.dll
657         $(MCS) -r:TestDriver.dll -out:$@ $<
658
659 # mkbundle works on ppc, but the pkg-config POC doesn't when run with make test
660 if POWERPC
661 test_platform:
662 else
663 # Can't use mkbundle on win32 since there is no static build there
664 # Can't run test-unhandled-exception on Windows because of all the debug popups...
665 if HOST_WIN32
666 test_platform:
667 else
668 # mkbundle uses the installed mono-2.pc so it won't work if there is no system mono
669 #test_platform: testbundle test-iomap-regression
670 test_platform:  test-iomap-regression
671 endif
672 endif
673
674 if X86
675 if HOST_WIN32
676 else
677 test_platform: test-eglib-remap
678 endif
679 endif
680
681 # Target to precompile the test executables
682 tests: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS) $(GSHARED_TESTS)
683
684 #
685 # Test that no symbols are missed in eglib-remap.h
686 #
687 OK_G_SYMBOLS='g_list\|g_slist\|g_concat_dir_and_file'
688 if NACL_CODEGEN
689 test-eglib-remap:
690 else
691 test-eglib-remap:
692         @echo "Testing eglib remap..."
693         @if which nm > /dev/null; then if nm $(top_builddir)/mono/mini/mono | grep -v $(OK_G_SYMBOLS) | grep 't g_'; then exit 1; else exit 0; fi; fi
694 endif
695
696 #
697 # Tests that the internals in mono/io-layer/messages.c are ok by triggering the 
698 # code that checks that the table is properly sorted
699 #
700 if NACL_CODEGEN
701 test-messages:
702 else
703 test-messages: w32message.exe
704         > test_messages.zero
705         $(with_mono_path) $(JITTEST_PROG_RUN) w32message.exe >& w32message.allout && cmp test_messages.zero w32message.allout
706 endif
707
708 if AMD64
709 test-sgen : sgen-tests
710 else
711 if X86
712 if HOST_WIN32
713 test-sgen :
714 else
715 test-sgen : sgen-tests
716 endif
717 else
718 if ARM
719 test-sgen : sgen-tests
720 else
721 if S390X
722 test-sgen : sgen-regular-tests
723 endif
724 endif
725 endif
726 endif
727
728 # Precompile the test assemblies in parallel
729 compile-tests:
730         $(MAKE) -j4 $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
731
732 test: assemblyresolve/test/asm.dll testjit test-generic-sharing test-type-load test_platform test-process-exit test-messages rm-empty-logs
733 test-wrench: compile-tests assemblyresolve/test/asm.dll testjit-wrench test-generic-sharing test-type-load test_platform test-process-exit test-sgen test-messages rm-empty-logs
734
735 # Remove empty .stdout and .stderr files for wrench
736 rm-empty-logs:
737         @echo "Removing empty logs..."
738         @find . '(' -name "*.stdout" -o -name "*.stderr" ')' -empty -exec rm {} \;
739
740 assemblyresolve/test/asm.dll:
741         $(MAKE) -C assemblyresolve prereq
742
743 TestDriver.dll:
744         $(MCS) -target:library -out:$@ $(srcdir)/../mini/TestDriver.cs
745
746 test_cs: $(TEST_PROG) $(TESTSI_CS) libtest.la
747         @failed=0; \
748         passed=0; \
749         for i in $(TESTSI_CS); do       \
750                 if $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' 'no-dump' $(RUNTIME_ARGS); \
751                 then \
752                         passed=`expr $${passed} + 1`; \
753                 else \
754                         if [ $$? = 2 ]; then break; fi; \
755                         failed=`expr $${failed} + 1`; \
756                 fi \
757         done; \
758         echo; echo ".cs: $${passed} test(s) passed. $${failed} test(s) did not pass."; echo
759
760 test_il: $(TEST_PROG) $(TESTSI_IL) libtest.la
761         @failed=0; \
762         passed=0; \
763         for i in $(TESTSI_IL); do       \
764                 if $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i "$(DISABLED_TESTS)" 'no-dump' $(RUNTIME_ARGS); \
765                 then \
766                         passed=`expr $${passed} + 1`; \
767                 else \
768                         if [ $$? = 2 ]; then break; fi; \
769                         failed=`expr $${failed} + 1`; \
770                 fi \
771         done; \
772         echo; echo ".il: $${passed} test(s) passed. $${failed} test(s) did not pass."; echo
773
774 testb: $(TEST_PROG) $(TESTBS)
775         for i in $(TESTBS); do  \
776                 $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' 'no-dump' $(RUNTIME_ARGS);   \
777         done
778
779 runtest-wrench: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
780         @failed=0; \
781         passed=0; \
782         failed_tests="";\
783         for i in $(TESTSI_CS) $(TESTBS) $(TESTSI_IL); do        \
784                 rm -f $${i}.so; \
785                 if [ x$(AOT) = x1 ]; then if echo $(AOT_DISABLED_TESTS) | grep -v -q $${i}; then $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $${i} > $${i}.aotlog 2>&1 || exit 1; fi; fi; \
786                 if $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$i '$(DISABLED_TESTS_WRENCH)' 'dump-output' $(RUNTIME_ARGS); \
787                 then \
788                         passed=`expr $${passed} + 1`; \
789                 else \
790                         if [ $$? = 2 ]; then break; fi; \
791                         failed=`expr $${failed} + 1`; \
792                         failed_tests="$${failed_tests} $$i"; \
793                 fi \
794         done; \
795         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
796         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
797           for i in $${failed_tests}; do echo $${i}; cat $${i}.stdout; cat $${i}.stderr; done; exit 1; fi
798
799 runtest-managed-wrench: test-runner.exe $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
800         @$(RUNTIME) ./test-runner.exe -j a --disabled '$(DISABLED_TESTS_WRENCH)' $(TESTSI_CS) $(TESTBS) $(TESTSI_IL)
801
802 testjit-wrench:
803         @if test x$(M) != x; then $(MAKE) runtest-managed-wrench; else $(MAKE) runtest-wrench; fi
804
805 runtest: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
806         @failed=0; \
807         passed=0; \
808         failed_tests="";\
809         rm -f testlist testlist.sorted; \
810         for i in $(TESTSI_CS) $(TESTBS) $(TESTSI_IL); do echo $${i} >> testlist; sort testlist > testlist.sorted; done; \
811         for i in `cat testlist.sorted`; do \
812                 rm -f $${i}.so; \
813                 if [ x$(AOT) = x1 ]; then if echo $(AOT_DISABLED_TESTS) | grep -v -q $${i}; then $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $${i} > $${i}.aotlog 2>&1 || exit 1; fi; fi; \
814                 if $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' 'no-dump' $(RUNTIME_ARGS); \
815                 then \
816                         passed=`expr $${passed} + 1`; \
817                 else \
818                         if [ $$? = 2 ]; then break; fi; \
819                         failed=`expr $${failed} + 1`; \
820                         failed_tests="$${failed_tests} $$i"; \
821                 fi \
822         done; \
823         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
824         rm -f testlist testlist.sorted; \
825         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
826           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
827
828 runtest-managed: test-runner.exe $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
829         @$(RUNTIME) ./test-runner.exe -j a --disabled '$(DISABLED_TESTS)' $(TESTSI_CS) $(TESTBS) $(TESTSI_IL)
830
831 testjit:
832         @if test x$(M) != x; then $(MAKE) runtest-managed; else $(MAKE) runtest; fi
833
834 testaot:
835         @$(MAKE) AOT=1 runtest
836
837 testtrace:
838         @$(MAKE) RUNTIME_ARGS="$${RUNTIME_ARGS} --trace" runtest
839
840 testinterp:
841         @$(MAKE) JITTEST_PROG_RUN="$(TEST_PROG_RUN)" runtest
842
843 testjitspeed: $(JITTEST_PROG) $(TESTBS)
844         for i in $(TESTBS); do  \
845                 echo $$i;       \
846                 time $(JITTEST_PROG) $$i;       \
847         done
848
849 test-iomap-regression: exists.cs
850         @$(MCS) $(srcdir)/exists.cs -out:exists.exe
851         @echo "Testing exists.exe..."
852         @MONO_IOMAP=all $(RUNTIME) exists.exe
853
854 stresstest: $(STRESS_TESTS)
855         @failed=0; \
856         passed=0; \
857         failed_tests="";\
858         for i in $(STRESS_TESTS); do    \
859                 if $(srcdir)/stress-runner.pl $$i ../mini/mono $(RUNTIME_ARGS); \
860                 then \
861                         passed=`expr $${passed} + 1`; \
862                 else \
863                         if [ $$? = 2 ]; then break; fi; \
864                         failed=`expr $${failed} + 1`; \
865                         failed_tests="$${failed_tests} $$i"; \
866                 fi \
867         done; \
868         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
869         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
870           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
871
872 testbundle: console.exe
873         @echo "Testing mkbundle..."
874         @$(MKBUNDLE) --static console.exe > mkbundle.stdout
875         @$(with_mono_path) MONO_CFG_DIR=$(mono_cfg_dir) MONO_SHARED_DIR=$(mono_build_root)/runtime ./a.out >> mkbundle.stdout
876         @- rm -rf a.out
877
878 EXTRA_DIST += load-missing.il t-missing.cs load-exceptions.cs
879 test-type-load: TestDriver.dll
880         @$(ILASM) /dll /output:load-missing.dll $(srcdir)/load-missing.il > /dev/null
881         @$(MCS) -t:library -out:t.dll -d:FOUND $(srcdir)/t-missing.cs
882         @$(MCS) -r:TestDriver.dll -r:load-missing.dll -r:t.dll -out:load-exceptions.exe $(srcdir)/load-exceptions.cs
883         @$(MCS) -t:library -out:t.dll $(srcdir)/t-missing.cs
884         @echo "Testing load-exception.exe..."
885         @$(RUNTIME) load-exceptions.exe > load-exceptions.exe.stdout 2> load-exceptions.exe.stderr
886
887 EXTRA_DIST += debug-casts.cs
888 # This depends on TLS, so its not ran by default
889 debug-casts:
890         @$(MCS) -r:TestDriver.dll $(srcdir)/debug-casts.cs
891         @$(RUNTIME) --debug=casts debug-casts.exe
892
893 EXTRA_DIST += sgen-bridge.cs sgen-descriptors.cs sgen-gshared-vtype.cs sgen-bridge-major-fragmentation.cs sgen-domain-unload.cs sgen-weakref-stress.cs sgen-cementing-stress.cs sgen-case-23400.cs      finalizer-wait.cs critical-finalizers.cs sgen-domain-unload-2.cs sgen-suspend.cs sgen-new-threads-dont-join-stw.cs sgen-bridge-xref.cs
894
895
896 #those are actually configurations, eg plain_sgen-descriptors.exe
897 #DISABLE_SGEN_TESTS =
898
899 SGEN_TESTS =    \
900         finalizer-wait.exe      \
901         critical-finalizers.exe \
902         sgen-descriptors.exe    \
903         sgen-gshared-vtype.exe  \
904         sgen-domain-unload.exe  \
905         sgen-weakref-stress.exe \
906         sgen-cementing-stress.exe       \
907         sgen-case-23400.exe     \
908         sgen-new-threads-dont-join-stw.exe
909
910 SGEN_CONFIGURATIONS =   \
911         "|plain"        \
912         "major=marksweep-par|ms-par"    \
913         "major=marksweep-conc|ms-conc"  \
914         "major=marksweep-conc,minor=split|ms-conc-split"        \
915         "minor=split|ms-split"  \
916         "minor=split,alloc-ratio=95|ms-split-95"
917
918 #FIXME We should move to use SGEN_CONFIGURATIONS once sgen supports trailling commas or its argument list.
919 SGEN_BRIDGE_CONFIGURATIONS =    \
920         "|plain"        \
921         ",major=marksweep-conc|ms-conc" \
922         ",minor=split|ms-split"
923
924 sgen-regular-tests: $(SGEN_TESTS)
925         @failed=0; \
926         passed=0; \
927         failed_tests="";\
928         for test in $+; do      \
929                 echo "...$$test";       \
930                 for conf in $(SGEN_CONFIGURATIONS); do  \
931                         name=`echo $$conf | cut -d\| -f 2`;     \
932                         params=`echo $$conf | cut -d\| -f 1`;   \
933                         test_name="$${test}|$${name}";  \
934                         if MONO_GC_PARAMS="$$params" MONO_ENV_OPTIONS="--gc=sgen" $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$test_name "$(DISABLED_TESTS_SGEN)" 'dump-output' $(RUNTIME_ARGS);     \
935                         then \
936                                 passed=`expr $${passed} + 1`; \
937                         else \
938                                 if [ $$? = 2 ]; then break; fi; \
939                                 failed=`expr $${failed} + 1`; \
940                                 failed_tests="$${failed_tests} $$test_name"; \
941                         fi \
942                 done    \
943         done;   \
944         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
945         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
946           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
947
948 sgen-bridge-tests1: sgen-bridge.exe sgen-bridge-major-fragmentation.exe
949         @failed=0; \
950         passed=0; \
951         failed_tests="";\
952         for test in $+; do      \
953                 echo "...$$test";       \
954                 for conf in $(SGEN_BRIDGE_CONFIGURATIONS); do   \
955                         name=`echo $$conf | cut -d\| -f 2`;     \
956                         params=`echo $$conf | cut -d\| -f 1`;   \
957                         test_name="$${test}|$${name}";  \
958                         if MONO_GC_PARAMS="bridge=Bridge$${params}" MONO_ENV_OPTIONS="--gc=sgen" $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$test_name "$(DISABLED_TESTS_SGEN)" 'dump-output' $(RUNTIME_ARGS);      \
959                         then \
960                                 passed=`expr $${passed} + 1`; \
961                         else \
962                                 if [ $$? = 2 ]; then break; fi; \
963                                 failed=`expr $${failed} + 1`; \
964                                 failed_tests="$${failed_tests} $$test_name"; \
965                         fi \
966                 done    \
967         done;   \
968         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
969         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
970           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
971
972 sgen-bridge-tests2: sgen-bridge-xref.exe
973         @failed=0; \
974         passed=0; \
975         failed_tests="";\
976         for test in $+; do      \
977                 echo "...$$test";       \
978                 for conf in $(SGEN_BRIDGE_CONFIGURATIONS); do   \
979                         name=`echo $$conf | cut -d\| -f 2`;     \
980                         params=`echo $$conf | cut -d\| -f 1`;   \
981                         test_name="$${test}|$${name}";  \
982                         if MONO_GC_PARAMS="bridge=2Bridge$${params}" MONO_ENV_OPTIONS="--gc=sgen" $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$test_name "$(DISABLED_TESTS_SGEN)" 'dump-output' $(RUNTIME_ARGS);     \
983                         then \
984                                 passed=`expr $${passed} + 1`; \
985                         else \
986                                 if [ $$? = 2 ]; then break; fi; \
987                                 failed=`expr $${failed} + 1`; \
988                                 failed_tests="$${failed_tests} $$test_name"; \
989                         fi \
990                 done    \
991         done;   \
992         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
993         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
994           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
995
996
997 sgen-bridge-tests: sgen-bridge-tests1 sgen-bridge-tests2
998
999 sgen-tests: sgen-regular-tests sgen-bridge-tests
1000
1001 AOT_CONFIGURATIONS=     \
1002         "|regular"      \
1003         "--gc=boehm|boehm"
1004
1005 #LLVM crashes, got to fix it first.
1006 #       "--llvm|llvm"   \
1007 #       "--llvm --gc=boehm|llvm+boehm"
1008
1009
1010 test-aot:
1011         @failed=0; \
1012         passed=0; \
1013         failed_tests="";\
1014         profile=net_4_5;        \
1015         tmpfile=`mktemp -t mono_aot_output` || exit 1;  \
1016         rm -f test-aot-$${name}.stdout test-aot-$${name}.stderr; \
1017         for assembly in $(mcs_topdir)/class/lib/$$profile/*.dll ; do    \
1018                 asm_name=`basename $$assembly`; \
1019                 echo "... $$asm_name";  \
1020                 for conf in $(AOT_CONFIGURATIONS); do   \
1021                         name=`echo $$conf | cut -d\| -f 2`;     \
1022                         params=`echo $$conf | cut -d\| -f 1`;   \
1023                         test_name="$${asm_name}|$${name}";      \
1024                         echo "  $$test_name";   \
1025                         if MONO_PATH=$(mcs_topdir)/class/lib/$$profile $(JITTEST_PROG_RUN) $$params --aot=outfile=$$tmpfile $$assembly >> test-aot-$${name}.stdout 2>> test-aot-$${name}.stderr;        \
1026                         then \
1027                                 passed=`expr $${passed} + 1`; \
1028                         else \
1029                                 failed=`expr $${failed} + 1`; \
1030                                 failed_tests="$${failed_tests} $$test_name"; \
1031                         fi \
1032                 done;   \
1033         done;   \
1034         rm      $$tmpfile;      \
1035         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
1036         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
1037         for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
1038
1039
1040 # Generated tests for runtime invoke
1041 EXTRA_DIST += gen-runtime-invoke.cs
1042 runtime-invoke.gen.exe: TestDriver.dll gen-runtime-invoke.exe
1043         $(RUNTIME) gen-runtime-invoke.exe > runtime-invoke.gen.cs
1044         $(MCS) -out:runtime-invoke.gen.exe -r:TestDriver.dll runtime-invoke.gen.cs
1045
1046 EXTRA_DIST += make-imt-test.cs
1047 imt_big_iface_test.exe: TestDriver.dll make-imt-test.exe
1048         $(RUNTIME) make-imt-test.exe > imt_big_iface_test.cs
1049         $(MCS) -out:imt_big_iface_test.exe -r:TestDriver.dll imt_big_iface_test.cs
1050
1051 EXTRA_DIST += test-inline-call-stack-library.cs test-inline-call-stack.cs
1052 test-inline-call-stack-library.dll: TestDriver.dll $(srcdir)/test-inline-call-stack-library.cs
1053         $(MCS) -t:library -out:test-inline-call-stack-library.dll $(srcdir)/test-inline-call-stack-library.cs
1054 test-inline-call-stack.exe: TestDriver.dll test-inline-call-stack-library.dll $(srcdir)/test-inline-call-stack.cs
1055         $(MCS) -r:TestDriver.dll -r:test-inline-call-stack-library.dll -out:test-inline-call-stack.exe $(srcdir)/test-inline-call-stack.cs
1056
1057 EXTRA_DIST += unhandled-exception-base-configuration.config
1058 EXTRA_DIST += unhandled-exception-legacy-configuration.config
1059 EXTRA_DIST += appdomain-unload.exe.config
1060 EXTRA_DIST += unhandled-exception-test-case.2.cs
1061 EXTRA_DIST += unhandled-exception-test-runner.2.cs
1062 unhandled-exception-test-case.1.cs: unhandled-exception-test-case.2.cs
1063         cp unhandled-exception-test-case.2.cs unhandled-exception-test-case.1.cs
1064 unhandled-exception-test-case-legacy.1.cs: unhandled-exception-test-case.1.cs
1065         cp unhandled-exception-test-case.1.cs unhandled-exception-test-case-legacy.1.cs
1066 unhandled-exception-test-case-legacy.2.cs: unhandled-exception-test-case.2.cs
1067         cp unhandled-exception-test-case.2.cs unhandled-exception-test-case-legacy.2.cs
1068 unhandled-exception-config_files: unhandled-exception-base-configuration.config unhandled-exception-legacy-configuration.config
1069         cp unhandled-exception-base-configuration.config unhandled-exception-test-case.1.exe.config
1070         cp unhandled-exception-base-configuration.config unhandled-exception-test-case.2.exe.config
1071         cp unhandled-exception-legacy-configuration.config unhandled-exception-test-case-legacy.1.exe.config
1072         cp unhandled-exception-legacy-configuration.config unhandled-exception-test-case-legacy.2.exe.config
1073 unhandled-exception-test-case.1.exe: unhandled-exception-test-case.1.cs
1074         $(MCS) /debug unhandled-exception-test-case.1.cs
1075 unhandled-exception-test-case-legacy.1.exe: unhandled-exception-test-case-legacy.1.cs
1076         $(MCS) /debug unhandled-exception-test-case-legacy.1.cs
1077 unhandled-exception-test-case.2.exe: unhandled-exception-test-case.2.cs
1078         $(MCS) /debug unhandled-exception-test-case.2.cs
1079 unhandled-exception-test-case-legacy.2.exe: unhandled-exception-test-case-legacy.2.cs
1080         $(MCS) /debug unhandled-exception-test-case-legacy.2.cs
1081 unhandled-exception-test-runner.2.exe: unhandled-exception-test-runner.2.cs
1082         $(MCS) /debug unhandled-exception-test-runner.2.cs
1083
1084 test-unhandled-exception: unhandled-exception-test-runner.2.exe unhandled-exception-config_files unhandled-exception-test-case.1.exe unhandled-exception-test-case-legacy.1.exe  unhandled-exception-test-case.2.exe unhandled-exception-test-case-legacy.2.exe
1085         $(RUNTIME) unhandled-exception-test-runner.2.exe RUNTIME:../mini/mono,GTC:F
1086
1087 # We use 'test-support-files' to handle an ordering issue between the 'mono/' and 'runtime/' directories
1088 bug-80307.exe: $(srcdir)/bug-80307.cs
1089         $(MCS) -r:System.Web -out:$@ $(srcdir)/bug-80307.cs
1090         cd $(top_builddir)/runtime && $(MAKE) test-support-files
1091
1092 EXTRA_DIST += bug-81673-interface.cs
1093 bug-81673.exe bug-81673-interface.dll: $(srcdir)/bug-81673.cs $(srcdir)/bug-81673-interface.cs
1094         $(MCS) -target:library -out:bug-81673-interface.dll $(srcdir)/bug-81673-interface.cs
1095         $(MCS) -out:bug-81673.exe -r:bug-81673-interface.dll $(srcdir)/bug-81673.cs
1096         $(MCS) -define:WITH_STOP -target:library -out:bug-81673-interface.dll $(srcdir)/bug-81673-interface.cs
1097
1098 EXTRA_DIST += bug-81691-a.cs bug-81691-b.cs
1099 bug-81691.exe bug-81691-b.dll: $(srcdir)/bug-81691.cs $(srcdir)/bug-81691-a.cs $(srcdir)/bug-81691-b.cs
1100         $(MCS) -target:library -out:bug-81691-a.dll $(srcdir)/bug-81691-a.cs
1101         $(MCS) -target:library -out:bug-81691-b.dll -r:bug-81691-a.dll $(srcdir)/bug-81691-b.cs
1102         $(MCS) -r:bug-81691-b.dll -out:bug-81691.exe $(srcdir)/bug-81691.cs
1103         rm -f bug-81691-a.dll
1104 bug-81691.exe: bug-81691-b.dll
1105
1106 EXTRA_DIST += bug-81466-lib.il
1107 bug-81466-lib.dll: bug-81466-lib.il
1108         $(ILASM) /dll /output:bug-81466-lib.dll $(srcdir)/bug-81466-lib.il
1109 bug-81466.exe: bug-81466.il bug-81466-lib.dll
1110         $(ILASM) /exe /output:bug-81466.exe $(srcdir)/bug-81466.il
1111
1112 EXTRA_DIST += bug-324535-il.il
1113 bug-324535-il.dll : bug-324535-il.il
1114         $(ILASM) /dll /output:bug-324535-il.dll $(srcdir)/bug-324535-il.il
1115 bug-324535.exe : bug-324535.cs bug-324535-il.dll
1116         $(MCS) -r:bug-324535-il.dll -out:bug-324535.exe $(srcdir)/bug-324535.cs
1117
1118 EXTRA_DIST += custom-modifiers.2.cs custom-modifiers-lib.il
1119 custom-modifiers-lib.dll: custom-modifiers-lib.il
1120         $(ILASM) /dll /output:custom-modifiers-lib.dll $(srcdir)/custom-modifiers-lib.il
1121 custom-modifiers.2.exe: custom-modifiers.2.cs custom-modifiers-lib.dll
1122         $(MCS) -r:custom-modifiers-lib.dll -out:custom-modifiers.2.exe $(srcdir)/custom-modifiers.2.cs
1123
1124 EXTRA_DIST += bug-382986-lib.cs
1125 bug-382986-lib.dll: bug-382986-lib.cs
1126         $(MCS) -target:library -out:$@ $(srcdir)/bug-382986-lib.cs
1127 bug-382986.exe: bug-382986.cs bug-382986-lib.dll
1128         $(MCS) -out:$@ -r:bug-382986-lib.dll $(srcdir)/bug-382986.cs
1129
1130 EXTRA_DIST += coreclr-security.cs
1131
1132 coreclr-security.exe : coreclr-security.cs
1133         $(SMCS) -out:coreclr-security.exe $(srcdir)/coreclr-security.cs
1134
1135 test-coreclr-security : coreclr-security.exe
1136         @echo "Testing coreclr-security.exe..."
1137         @$(RUNTIME_MOONLIGHT) --security=core-clr-test coreclr-security.exe
1138
1139 EXTRA_DIST += generic-unboxing.2.il
1140 generic-unboxing.2.dll : generic-unboxing.2.il
1141         $(ILASM) /dll /output:generic-unboxing.2.dll $(srcdir)/generic-unboxing.2.il
1142
1143 EXTRA_DIST += generic-boxing.2.il
1144 generic-boxing.2.dll : generic-boxing.2.il generic-unboxing.2.dll
1145         $(ILASM) /dll /output:generic-boxing.2.dll $(srcdir)/generic-boxing.2.il
1146
1147 EXTRA_DIST += generic-unbox.2.cs
1148 generic-unbox.2.exe : generic-unbox.2.cs generic-unboxing.2.dll
1149         $(MCS) -r:generic-unboxing.2.dll -out:$@ $(srcdir)/generic-unbox.2.cs
1150
1151 EXTRA_DIST += generic-box.2.cs
1152 generic-box.2.exe : generic-box.2.cs generic-unboxing.2.dll generic-boxing.2.dll
1153         $(MCS) -r:generic-unboxing.2.dll,generic-boxing.2.dll -out:$@ $(srcdir)/generic-box.2.cs
1154
1155 EXTRA_DIST += generic-delegate2.2.cs generic-delegate2-lib.2.il
1156 generic-delegate2-lib.2.dll : generic-delegate2-lib.2.il
1157         $(ILASM) /dll /output:$@ $(srcdir)/generic-delegate2-lib.2.il
1158 generic-delegate2.2.exe : generic-delegate2.2.cs generic-delegate2-lib.2.dll
1159         $(MCS) -r:generic-delegate2-lib.2.dll -out:$@ $(srcdir)/generic-delegate2.2.cs
1160
1161 bug-3903.exe: bug-3903.cs
1162         $(MCS) -sdk:2 $(srcdir)/bug-3903.cs -out:$@
1163
1164 gshared: test-generic-sharing
1165
1166 gshared-aot:
1167         @$(MAKE) AOT=1 gshared
1168
1169 GSHARED_TESTS = \
1170                 generics-sharing.2.exe shared-generic-methods.2.exe     \
1171                 shared-generic-synchronized.2.exe generic-initobj.2.exe         \
1172                 generics-sharing-other-exc.2.exe generic-box.2.exe              \
1173                 generic-unbox.2.exe generic-delegate.2.exe generic-sizeof.2.exe \
1174                 generic-ldobj.2.exe generic-mkrefany.2.exe                      \
1175                 generic-refanyval.2.exe generic-ldtoken.2.exe                   \
1176                 generic-ldtoken-method.2.exe  generic-ldtoken-field.2.exe       \
1177                 generic-virtual.2.exe generic-tailcall.2.exe                    \
1178                 generic-interface-methods.2.exe generic-array-type.2.exe        \
1179                 generic-method-patching.2.exe generic-static-methods.2.exe      \
1180                 generic-null-call.2.exe generic-tailcall2.2.exe                 \
1181                 generic-array-exc.2.exe generic-special.2.exe                   \
1182                 generic-exceptions.2.exe generic-delegate2.2.exe                \
1183                 generic-virtual2.2.exe generic-valuetype-interface.2.exe        \
1184                 generic-valuetype-newobj.2.exe generic-valuetype-newobj2.2.exe  \
1185                 generic-getgenericarguments.2.exe generic-type-builder.2.exe    \
1186                 generic-synchronized.2.exe generic-delegate-ctor.2.exe          \
1187                 generic-constrained.2.exe bug-431413.2.exe                      \
1188                 generic-virtual-invoke.2.exe generic-typedef.2.exe              \
1189                 generic-marshalbyref.2.exe bug-459285.2.exe bug-461198.2.exe    \
1190                 generic-sealed-virtual.2.exe generic-system-arrays.2.exe        \
1191                 generic-stack-traces.2.exe generic-stack-traces2.2.exe          \
1192                 bug-472600.2.exe bug-473482.2.exe bug-473999.2.exe              \
1193                 bug-479763.2.exe generic-xdomain.2.exe                          \
1194                 generic-type-load-exception.2.exe bug-616463.exe        \
1195                 bug-1147.exe
1196
1197 test-generic-sharing-normal: $(GSHARED_TESTS)
1198         @for fn in $+ ; do      \
1199                 echo "Testing $$fn ...";        \
1200                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared                $$fn > $$fn.stdout || exit 1;     \
1201                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,shared         $$fn > $$fn.stdout || exit 1;     \
1202                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,-inline        $$fn > $$fn.stdout || exit 1;     \
1203                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,-inline,shared $$fn > $fn.stdout || exit 1;      \
1204                 if [ x$(AOT) = x1 ]; then MONO_GENERIC_SHARING=all $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $$fn > /dev/null || exit 1; MONO_GENERIC_SHARING=all $(RUNTIME) $$fn > $$fn.stdout || exit 1; fi; \
1205         done
1206
1207 test-generic-sharing-managed: test-runner.exe $(GSHARED_TESTS)
1208         @$(RUNTIME) ./test-runner.exe -j a --opt-sets "gshared gshared,shared gshared,-inline gshared,-inline,shared" $(GSHARED_TESTS)
1209
1210 if NACL_CODEGEN
1211 test-generic-sharing:
1212 else
1213 test-generic-sharing:
1214         @if test x$(M) != x; then $(MAKE) test-generic-sharing-managed; else $(MAKE) test-generic-sharing-normal; fi
1215 endif
1216
1217 EXTRA_DIST += async-exceptions.cs
1218 async-exceptions.exe : async-exceptions.cs
1219         $(MCS) -out:async-exceptions.exe $(srcdir)/async-exceptions.cs
1220 test-async-exceptions : async-exceptions.exe
1221         for i in `echo 0 1 2 3 4 5 6 7 8 9 10`; do $(RUNTIME) --inject-async-exc Tests:foo $$i async-exceptions.exe || exit 1; done
1222         for i in `echo 0 1 2 3 4 5 6 7 8 9 10`; do $(RUNTIME) --inject-async-exc Tests:bar $$i async-exceptions.exe || exit 1; done
1223
1224 EXTRA_DIST += modules.cs modules-m1.cs
1225 modules-m1.netmodule: modules-m1.cs
1226         $(MCS) -out:$@ /target:module $(srcdir)/modules-m1.cs
1227 modules.exe: modules.cs modules-m1.netmodule TestDriver.dll
1228         $(MCS) -out:$@ /addmodule:modules-m1.netmodule -r:TestDriver.dll $(srcdir)/modules.cs
1229
1230 # Useful if mono is compiled with --enable-shared=no
1231 patch-libtool:
1232         cp "../../libtool" .
1233         sed -e 's,build_libtool_libs=no,build_libtool_libs=yes,g' libtool > 2; mv 2 libtool
1234         sed -e 's,LIBTOOL =,LIBTOOL2 =,g' Makefile > 2 && echo "LIBTOOL = bash ./libtool" > 1 && cat 1 2 > Makefile
1235         touch libtest.c
1236
1237
1238 if NACL_CODEGEN
1239 test-process-exit:
1240 else
1241 EXTRA_DIST += bug-438454.cs bug-438454.exe.stdout.expected threadpool-in-processexit.cs threadpool-in-processexit.exe.stdout.expected
1242 test-process-exit:
1243         @$(MCS) $(srcdir)/bug-438454.cs -out:bug-438454.exe
1244         @echo "Testing bug-438454.exe..."
1245         @$(RUNTIME) bug-438454.exe > bug-438454.exe.stdout
1246         @diff -w bug-438454.exe.stdout $(srcdir)/bug-438454.exe.stdout.expected
1247         @$(MCS) $(srcdir)/threadpool-in-processexit.cs -out:threadpool-in-processexit.exe
1248         @echo "Testing threadpool-in-processexit.exe..."
1249         @$(RUNTIME) threadpool-in-processexit.exe > threadpool-in-processexit.exe.stdout
1250         @diff -w threadpool-in-processexit.exe.stdout $(srcdir)/threadpool-in-processexit.exe.stdout.expected
1251 endif
1252
1253 OOM_TESTS =     \
1254         gc-oom-handling.exe     \
1255         gc-oom-handling2.exe
1256
1257
1258 test-oom: $(OOM_TESTS)
1259         @for fn in $+ ; do      \
1260                 echo "Testing $$fn ...";        \
1261                 MONO_GC_PARAMS=max-heap-size=16m,major=marksweep-par MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1262                 MONO_GC_PARAMS=max-heap-size=16m MONO_ENV_OPTIONS="--gc=sgen"                     $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1263                 MONO_GC_PARAMS=max-heap-size=16m                                                  $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1264         done
1265
1266
1267 noinst_LTLIBRARIES = libtest.la
1268
1269 AM_CPPFLAGS = $(GLIB_CFLAGS) $(GMODULE_CFLAGS)
1270
1271 if HOST_WIN32
1272 # gcc-3.4.4 emits incorrect code when making indirect calls to stdcall functions using a tail call
1273 # This shows up when compiling mono_test_marshal_delegate ()
1274 libtest_la_CFLAGS=-fno-optimize-sibling-calls
1275 # the exported names created by gcc for stdcall functions are missing the leading _, so MS.NET
1276 # can't find them. So we use --kill-at to remove the @ suffix as well.
1277 libtest_la_LDFLAGS=-no-undefined -rpath `pwd` -Wl,--kill-at
1278 else
1279 libtest_la_LDFLAGS = -rpath `pwd`
1280 endif
1281 libtest_la_SOURCES = libtest.c
1282 libtest_la_LIBADD = $(GLIB_LIBS) $(LIBICONV)
1283
1284 CLEANFILES = $(TESTSI_CS) $(TESTSI_IL) $(STRESS_TESTS) *.dll *.stdout *.aotlog *.exe stest.dat